pipeline {
    agent any

    parameters{
        choice(name: 'APP_ENV', choices: ['dev','uat','prod'], description: '')
    }

    environment{
      Project_Name='app'
      Registry_Url='35.187.244.24:5000'
    }

    stages {

        stage('SCM & Config Env') {
            steps {
                sh """
                    rm -rf app;
                """
                script{
                    switch (APP_ENV) {
                        case 'dev':
                            sh """
                                git clone --branch dev https://gitlab.com/yanphearak.program/app.git;
                                cd ${Project_Name};
                                echo '<h1>Hello Development</h1>' > index.html;
                            """
                            break
                        case 'uat':
                            sh """
                                git clone --branch uat https://gitlab.com/yanphearak.program/app.git;
                                cd ${Project_Name};
                                echo '<h1>Hello UAT</h1>' > index.html;
                            """
                            break
                        case 'prod':
                            sh """
                                git clone --branch main https://gitlab.com/yanphearak.program/app.git;
                                cd ${Project_Name};
                                echo '<h1>Hello Production</h1>' > index.html;
                            """
                            break
                        default:
                            error "Invalid environment selected: $envVar"
                    }
                }
            }
        }

        stage('Build Image & Push to Registry') {
            steps {
                script{
                    sh """
                        cd ${Project_Name};
                        docker build -t ${Registry_Url}/${Project_Name}:${BUILD_NUMBER} .
                        docker push     ${Registry_Url}/${Project_Name}:${BUILD_NUMBER}
                    """
                }
            }
        }

        stage("Deploy"){
            steps{
                script{
                    sh """
                        cd ${WORKSPACE};
                        ls -la;
                        ansible-playbook deployment.yml  \
                        -i inventory                     \
                        -e project_name=${Project_Name}  \
                        -e registry_url=${Registry_Url}  \
                        -e version=${BUILD_NUMBER}
                    """
                }
            }
        }
    }
    post {
        always{
            script{
                sh '''
                    curl https://api.telegram.org/bot123456:ABC-DEF1234ghIkl-zyx57W2v1u123ew11/sendMessage?chat_id=1234&text=hi
                '''
            }
        }
    }



}